# 
# post.rb
# 
# Created on Sep 26, 2007, 10:26:30 AM
# 
# To change this template, choose Tools | Templates
# and open the template in the editor.
 
require 'java'

include_class 'javax.persistence.Persistence'
include_class 'javax.persistence.EntityManager'
include_class 'javax.persistence.EntityManagerFactory'
include_class 'java.util.List'
include_class 'java.lang.Long'
include_class 'entity.Posts'  

class Post
  
  attr_accessor :id, :title, :body
  
  def initialize(attributes = nil)
    if !attributes.nil?
      @title = attributes[:title]
      @body = attributes[:body]
    end
  end    
  
  def save
    p = Posts.new
    p.title = title
    p.body = body
    em = Post.getEntityManager
    em.getTransaction().begin()
    em.persist(p);    
    em.getTransaction().commit()
    return true
  end   
  
  def update_attributes(attributes)
    p = Posts.new
    p.id = id
    p.title = attributes[:title]
    p.body  = attributes[:body]
    em = Post.getEntityManager
    em.getTransaction().begin()
    em.merge(p);    
    em.getTransaction().commit()
    return true    
  end    
  
  # Copied from base.rb. Allows us to specify post rather than post.id in list.rhtml.
  # Enables Active Record objects to be used as URL parameters in Action Pack automatically.
  def to_param
    # We can't use alias_method here, because method 'id' optimizes itself on the fly.
    (id = self.id) ? id.to_s : nil # Be sure to stringify the id for routes
  end     
  
  # Called by `paginate'
  def self.count(*args) 
    query = getEntityManager.createQuery("SELECT p FROM Posts p") 
    count = query.getResultList().size();
    puts count
  end

  def self.find(*args)
    case args.first
    when :all   then find_all
    else             find_from_id(args.first)
    end
  end
  
  private
       
  def self.getEntityManager
    emf = Persistence.createEntityManagerFactory("PostPU")
    return emf.createEntityManager() 
  end

  def self.find_all
    query = getEntityManager.createQuery("SELECT p FROM Posts p")
    list = query.getResultList()
      
    posts = []  #Create a new array to return
      
    list.each {|post|
      temp = Post.new
      temp.id = post.getId
      temp.title = post.getTitle
      temp.body = post.getBody 
      posts << temp
    }
    return posts
  end    

  def self.find_from_id(id)
    result = getEntityManager.find(Posts.java_class, Long.new(id))

    post = Post.new
    post.id = result.get_id
    post.title = result.get_title
    post.body = result.get_body
    
    return post
  end    



  
end
